import unittest

import lib

class TestContainer(unittest.TestCase):
    def setUp(self):
        self.ob = lib.Container()

class TestEntity(unittest.TestCase):
    def setUp(self):
        self.context = lib.Context()
        self.context.starting_plane = lib.create_block(self.context, 10, 10)
    def test_create_entity_populates_the_container(self):
        space = self.context.starting_plane[ (0, 0) ]
        ent = lib.hatch_entity( context=self.context
                              , container=space.container
                              , c='@'
                              , name='example'
                              , size=lib.ES_PILL
                              )
        self.assertTrue(space.container.contains(ent))

class TestPlayerSetup(unittest.TestCase):
    def setUp(self):
        self.context = lib.Context()
        self.context.starting_plane = lib.create_block(self.context, 10, 10)
        lib.declare_player_actor(self.context)
    def test_player_has_matches(self):
        self.assertTrue( len( [i for i
                                 in self.context.player.ent.inv
                                 if i.name == lib.ENT_MATCHES
                                 ] )
                       )

class TestMotherNature(object):
    def setUp(self):
        self.context = lib.Context()
        self.context.starting_plane = lib.create_block(self.context, 10, 10)
        self.space = self.context.starting_plane[ (0, 0) ]
        self.a_seed = lib.declare_bean_seed(self.context, self.space.container)

        self.ob = lib.MotherNature(self.context)
    def test_an_unplanted_seed_does_not_grow(self):
        pass
    def test_tracks_a_newly_planted_seed(self):
        pass
    def test_seed_grows_at_predictable_rate(self):
        pass

class TestSpace(unittest.TestCase):
    def setUp(self):
        pass

class TestPlane(unittest.TestCase):
    def setUp(self):
        pass

class TestLadyOfTheLake(unittest.TestCase):
    def setUp(self):
        context = lib.Context()
        self.ob = lib.LadyOfTheLake(context)
    def test_lady_of_the_lake(self):
        pass # xxx feels too distant to do a good job of now.


